#include "testlib.h"
#include "parmpars.hpp"
#include <bits/stdc++.h>
using namespace std;

const int MAX = 5e5;
int T[MAX], A[MAX], B[MAX];

vector<int> numbers;

void type_1(int pos, int n) {
    
    DECLARE_D(int, t1k, n);
    DECLARE_D(int, t1t, 0);
    DECLARE_D(int, t1tt, 0);
    
    T[pos] = 1;
    
    if (t1tt == 0) {
        A[pos] = rnd.next(1, n);
        B[pos] = rnd.wnext(t1k, t1t) + 1;
    } else {
        A[pos] = numbers[rnd.next(numbers.size())];
        B[pos] = rnd.next(numbers.size()) + 1;
    }
}

void __type_2(int pos, int a, int b) {
    T[pos] = 2;
    A[pos] = a;
    B[pos] = b;
}

void type_2(int pos, int n) {
    
    DECLARE_D(int, t2t, 0);
    int a, b;
    if (t2t == 0) {
        a = rnd.next(1, n);
        b = rnd.next(1, n);
    } else if (t2t == 1) {
        a = rnd.next(1, n - 1);
        b = a + 1;
    } else if (t2t == 2) {
        a = n / 2 + 1;
        b = n / 2 + 2;
    }
    __type_2(pos, a, b);
}

void type_3(int pos, int n) {
    
    DECLARE_D(int, t3t, 0);
    
    T[pos] = 3;
    if (t3t == 0) {
        DECLARE_D(int, t3m, 0);
        DECLARE_D(int, t3k, 0);
        A[pos] = rnd.wnext(pos - t3m, t3k) + t3m;
    } else if (t3t == 1) {
        DECLARE(int, t3m);
        A[pos] = t3m;
    }
}

void random_type(int i, int n) {
    
    DECLARE_D(int, t1, 100);
    DECLARE_D(int, t2, 100);
    DECLARE_D(int, t3, 100);
    
    int t0 = rnd.next(t1 + t2 + t3);
    if (t0 < t1) {
        type_1(i, n);
    } else if (t0 < t1 + t2) {
        type_2(i, n);
    } else {
        type_3(i, n);
    }
}

int main(int argc, char* argv[]) {
    initGenerator(argc, argv, 1);
    
    DECLARE(int, g);
    DECLARE_D(int, n, MAX);
    DECLARE_D(int, q, MAX);
    
    DECLARE_D(int, f, 0);
    
    cout << n << " " << q << " " << g << endl;
    
    if (f == 0) {
        for (int i = 1; i <= q; i++) {
            random_type(i, n);
        }
    } else if (f == 1) {
        
        DECLARE_D(int, f1, n / 2);
        
        for (int i = 1; i <= q; i++) {
            if (i <= f1) {
                type_2(i, n);
            } else {
                random_type(i, n);
            }
        }
    }  else if (f == 2) {
        DECLARE_D(int, f1, n / 2);
        
        for (int i = 1; i <= q; i++) {
            if (i <= f1) {
                __type_2(i, i, i + 1);
            } else {
                random_type(i, n);
            }
        }
    } else if (f == 3) {
        DECLARE_D(int, f1, n / 2);
        DECLARE_D(int, f2, 5);
        f2 = f1 / f2;
        int pos = 1;
        for (int i = 1; i <= q; i++) {
            if (i <= f1) {
                if (rnd.next(f2) == 0)
                    pos++;
                __type_2(i, pos, pos + 1);
                pos++;
            } else {
                random_type(i, n);
            }
        }
    } else if (f == 4) {
        DECLARE_D(int, f1, 0);
        DECLARE_D(int, f2, 0);
        DECLARE_D(int, f3, n);
        int pos = 0;
        for (int i = 1; i + 2 <= f3; i++) {
            if (f1 == 0 || rnd.next(f1))
                __type_2(++pos, i, i + 2);
        }
        if (f2 == 0) {
            for (int i = pos + 1; i <= q; i++) {
                random_type(i, n);
            }
        } else {
            int r = 1;
            for (int i = pos + 1; i <= q; i++) {
                if (r == 1) {
                    type_1(i, n);
                } else if (r == 2) {
                    type_2(i, n);
                } else {
                    type_3(i, n);
                }
                r = (r + 1) % 3;
            }
        }
        
    } else if (f == 5) {
        int pos = 0;
        for (int i = 1; i + 1 <= n; i++) {
            if(i - 1 == n / 2) {
                continue;
            }
            __type_2(++pos, i, i + 1);
        }
        for (int i = pos + 1; i <= q; i++) {
            random_type(i, n);
        }
    } else if (f == 6) {
        int pos = 0;
        DECLARE_D(int, f1, 1);
        DECLARE_D(int, f2, n);
        vector<int> v, v2;
        for (int i = 1; i <= n; i++) {
            if (i % 2 == 1 || f1 != 0)
                v.push_back(i);
        }
        shuffle(v.begin(), v.end());
        while((int) v.size() > f2) {
            v.pop_back();
        }
        for (int a : v) {
            numbers.push_back(a);
        }
        while((int) v.size() > 1) {
            while((int) v.size() > 1) {
                int a = v.back();
                v.pop_back();
                int b = v.back();
                v.pop_back();
                __type_2(++pos, a, b);
                v2.push_back(a);
            }
            if (!v.empty()) {
                v2.push_back(v.back());
                v.pop_back();
            }
            swap(v, v2);
        }

        for (int i = pos + 1; i <= q; i++) {
            random_type(i, n);
        }
    } else if (f == 7) {
        int pos = 0;
        for (int i = 1; i + 2 <= n; i += 2) {
            __type_2(++pos, i, i + 2);
        }
        for (int i = pos + 1; i <= q; i++) {
            random_type(i, n);
        }
    } 
    for (int i = 1; i <= q; i++) {
        cout << T[i] << " ";
        if (T[i] == 3) {
            cout << A[i] << endl;
        } else {
            cout << A[i] << " " << B[i] << endl;
        }
    }
    return 0;
}
